Index: /pykota/trunk/man/sv_SE/pkbanner.1
===================================================================
--- /pykota/trunk/man/sv_SE/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/sv_SE/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/pt_PT/pkbanner.1
===================================================================
--- /pykota/trunk/man/pt_PT/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/pt_PT/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/el_GR/pkbanner.1
===================================================================
--- /pykota/trunk/man/el_GR/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/el_GR/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/nb_NO/pkbanner.1
===================================================================
--- /pykota/trunk/man/nb_NO/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/nb_NO/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/fr_FR/pkbanner.1
===================================================================
--- /pykota/trunk/man/fr_FR/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/fr_FR/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/es_ES/pkbanner.1
===================================================================
--- /pykota/trunk/man/es_ES/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/es_ES/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/pkbanner.1
===================================================================
--- /pykota/trunk/man/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/de_DE/pkbanner.1
===================================================================
--- /pykota/trunk/man/de_DE/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/de_DE/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/pt_BR/pkbanner.1
===================================================================
--- /pykota/trunk/man/pt_BR/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/pt_BR/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/th_TH/pkbanner.1
===================================================================
--- /pykota/trunk/man/th_TH/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/th_TH/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/it_IT/pkbanner.1
===================================================================
--- /pykota/trunk/man/it_IT/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/it_IT/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.
Index: /pykota/trunk/man/fr_BE/pkbanner.1
===================================================================
--- /pykota/trunk/man/fr_BE/pkbanner.1 (revision 1937)
+++ /pykota/trunk/man/fr_BE/pkbanner.1 (revision 1939)
@@ -23,5 +23,5 @@
 \fB\-l\fR | \fB\-\-logo\fR img
 Use the image as the banner's logo. The logo will
-be drawn at the top center of the page. The default
+be drawn at the center top of the page. The default
 logo is /usr/share/pykota/logos/pykota.jpeg
 .TP
@@ -32,5 +32,5 @@
 .TP
 \fB\-s\fR | \fB\-\-savetoner\fR s
-Sets the text luminosity factor to d%. This can be
+Sets the text luminosity factor to s%. This can be
 used to save toner. The default value is 0, which
 means that no toner saving will be done.