Index: pykota/trunk/initscripts/ldap/pykota.schema
===================================================================
--- pykota/trunk/initscripts/ldap/pykota.schema (revision 2024)
+++ pykota/trunk/initscripts/ldap/pykota.schema (revision 2028)
@@ -4,5 +4,4 @@
 #
 # LDAP Schema for Pykota Quota System
-# Version 0.2
 #
 # Include it in OpenLDAP's configuration file (/etc/ldap/slapd.conf)
Index: pykota/trunk/initscripts/ldap/README.ldap
===================================================================
--- pykota/trunk/initscripts/ldap/README.ldap (revision 1354)
+++ pykota/trunk/initscripts/ldap/README.ldap (revision 2028)
@@ -3,5 +3,5 @@
 PyKota - Print Quota for CUPS and LPRng
 
-(c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pykota/trunk/initscripts/postgresql/README.postgresql
===================================================================
--- pykota/trunk/initscripts/postgresql/README.postgresql (revision 1473)
+++ pykota/trunk/initscripts/postgresql/README.postgresql (revision 2028)
@@ -3,5 +3,5 @@
 PyKota - Print Quota for CUPS and LPRng
 
-(c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pykota/trunk/initscripts/postgresql/pykota-postgresql.sql
===================================================================
--- pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 2024)
+++ pykota/trunk/initscripts/postgresql/pykota-postgresql.sql (revision 2028)
@@ -2,5 +2,5 @@
 -- PyKota - Print Quotas for CUPS and LPRng
 --
--- (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+-- (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 -- This program is free software; you can redistribute it and/or modify
 -- it under the terms of the GNU General Public License as published by
@@ -20,4 +20,7 @@
 --
 -- $Log$
+-- Revision 1.14  2005/01/17 08:44:24  jalet
+-- Modified copyright years
+--
 -- Revision 1.13  2005/01/10 23:23:25  jalet
 -- Added the billing code to the history
Index: pykota/trunk/initscripts/mysql/README.mysql
===================================================================
--- pykota/trunk/initscripts/mysql/README.mysql (revision 1559)
+++ pykota/trunk/initscripts/mysql/README.mysql (revision 2028)
@@ -3,5 +3,5 @@
 PyKota - Print Quota for CUPS and LPRng
 
-(c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pykota/trunk/initscripts/mysql/pykota-mysql.sql
===================================================================
--- pykota/trunk/initscripts/mysql/pykota-mysql.sql (revision 1558)
+++ pykota/trunk/initscripts/mysql/pykota-mysql.sql (revision 2028)
@@ -2,5 +2,5 @@
 -- PyKota - Print Quotas for CUPS and LPRng
 --
--- (c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+-- (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 -- This program is free software; you can redistribute it and/or modify
 -- it under the terms of the GNU General Public License as published by
@@ -20,4 +20,7 @@
 --
 -- $Log$
+-- Revision 1.2  2005/01/17 08:44:24  jalet
+-- Modified copyright years
+--
 -- Revision 1.1  2004/06/20 19:14:20  jalet
 -- Added first draft of MySQL initialization script
Index: pykota/trunk/initscripts/README
===================================================================
--- pykota/trunk/initscripts/README (revision 1473)
+++ pykota/trunk/initscripts/README (revision 2028)
@@ -3,5 +3,5 @@
 PyKota - Print Quota for CUPS and LPRng
 
-(c) 2003-2004 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by